#!/bin/sh
# This comment continues on in Tcl, but not in sh \
exec wish "$0" ${1+"$@"}
# Command line options
set nonet 0
if {[string match "--nonet" [lindex $argv 0]]} {
    set nonet 1
}

# Directory knowledge
set mmpe(dirrel) [string trimright [file dirname [info script]] ./]
set mmpe(dirabs) [file join [pwd] $mmpe(dirrel)]
set mmpe(libdir) [file join [file dirname $mmpe(dirabs)] oommf library]
 #defines functions used in dmif
 #ReadFile read a file into an input  buffer.  Does not parse the file  
#*************************************************************************#
proc ReadFile {filename } {
 puts "Reading $filename..."
 global inbuff
 set inbuff [list]
 set count 0 
 if {[file readable $filename]} {
  set file1Id [open $filename "r"]
    while { [gets $file1Id data]>=0} {
      #puts $data
      lappend inbuff $data
      incr count
    }
  close $file1Id
 }
if {$count == 0} {puts "Empty file or file not readable"}
return $count
}   
#*************************************************************************#
proc ChangeMif { Ref NewValue } {
 global MifKnow
 set datanow [lindex $MifKnow($Ref) 0]
 set MifKnow($Ref) [list $datanow ]
 set NewValue [split $NewValue]
 foreach val $NewValue {
   lappend MifKnow($Ref) $val
 }
}
#*************************************************************************#
#set up an array that contains the entries of a MifFile
#What is needed in a mif file is stored in state.dat
proc KnowWhat {filename} {
 global inbuff MifKnow KnowOrder
 set listsize [ReadFile $filename]
 for {set i 0} {$i<$listsize} {incr i} {
  set shortbuff [lindex $inbuff $i] 
  #puts $shortbuff
  set shortbuff [split $shortbuff :]
  set MifKnow([lindex $shortbuff 0]) [lindex $shortbuff 1]
  set KnowOrder([lindex $shortbuff 2]) [lindex $shortbuff 0]
 }
}
  #Reads and understands the mif file <filename> (must run KnowWhat first) 
  #(needs ReadFile) puts result in array MifKnow
#*************************************************************************#
proc ParseFile {filename} {
 global inbuff MifKnow FieldState
 set listsize [ReadFile $filename]
 set firstbuff vals
 set FieldCount 0 
 for {set i 0} {$i<$listsize} {incr i} {
   set shortbuff [string trim [lindex $inbuff $i]]
   regexp -nocase {^[^#]*[^#]*} $shortbuff firstbuff
  
   if {[string length $firstbuff]!=0} {
      #set firstbuff [string tolower $firstbuff]
      regexp {^([^:]*)(:)(.*)} $firstbuff fluf prefix fluf2 suffix
      set prefix [string tolower [string trim $prefix]]
      set suffix [string trim $suffix]
      if [info exists MifKnow($prefix)] { 
	  if {$prefix=="field range"} {
	    incr FieldCount
	    set FieldState($FieldCount) $suffix
	    #puts "$FieldState($FieldCount) $FieldCount"
	 }
	ChangeMif $prefix $suffix
      }
   }
 }
}
#*************************************************************************#
proc CallBack {filename num} {
    global MifKnow MifBak                                    
    foreach i [array names MifBak] {set MifKnow($i) $MifBak($i)}
    EntryChange $filename $num
}
#*************************************************************************#
proc CallNew {num} {
    global TopButton
    set size [expr [array size TopButton] -1]
    if {$num<0} {set num $size}
    if {$num>$size} {set num 0}                  
    set filename $TopButton($num)
    puts "$num  $TopButton($num)"
    EntryChange $filename $num
}
#*************************************************************************#
proc MultiButton {type name label label2 btext bchange width1 width2 command command2 args} {
     #puts "$type $name $label $btext $bchange $width1 $width2 $command $command2 $args"
     global v vals val
     frame $name
     event add <<INVOKE>> <Shift-F1> 
     if {$type==0} {
      #check only 
      radiobutton $name.button -text $bchange \
                  -value $btext -command $command2 -anchor w
      pack $name.button -side left 
     }
     if {$type==1} {
      #just a label
      label $name.label -text $label -anchor w
      pack $name.label -side left
     }
     if {$type==2} {
      #label and radiobutton
      label $name.label -text "$label:" 
      radiobutton $name.button -text\
                  $bchange -value $btext -command $command2
      pack $name.label -side left
      pack $name.button -side right
     }
     if {$type==3} {
      #check + label + entry
	radiobutton $name.button -text\
                  $bchange -value $btext -command $command2 
	label $name.label -text "$label:" -width $width1 -anchor w
	eval  {entry $name.entry -width $width1 -relief sunken} $args
	pack $name.button -side left
	pack $name.entry $name.label -side right
	$name.entry config -state disabled
	set a ".[lindex [split $name .] 1]"
	bind $name.entry <<INVOKE>> $command
	bind $name.entry <Return> "$command;focus $a.next.ok;break"
	bind $name.entry <Tab> $command
	
     }
     if {$type==4} {
      #label + entry wigit
	label $name.label -text "$label:" -width $width1 -anchor w
	eval  {entry $name.entry -relief sunken} $args
	pack $name.label -side left
	pack $name.entry -side right -fill x -expand true 
	set a ".[lindex [split $name .] 1]"
        bind $name.entry <<INVOKE>> $command
	bind $name.entry <Return> "$command;focus $a.next.ok;break"
	bind $name.entry <Button-1> "Set $name"
	bind $name.entry <Tab> $command
	
     }
	if {$type==5} {
      #check + label + entry + label + entry 
	radiobutton $name.button -text\
                  $bchange -value $btext -command $command2 
	label $name.label -text $label -width $width1 -anchor w
	eval  {entry $name.entry -relief sunken -width $width1} $args
	label $name.label2 -text $label2 -width $width1 -anchor w
	eval  {entry $name.entry2 -relief sunken -width $width1} $args
	pack $name.button -side left
	pack $name.entry $name.label $name.entry2 $name.label2 -side right
	bind $name.entry <Tab> $command
	set a ".[lindex [split $name .] 1]"
        bind $name.entry <<INVOKE>> $command
	bind $name.entry <Return> "$command;focus $a.next.ok;break"
	bind $name.entry <Button-1> "Set $name"
	bind $name.entry2 <Tab> $command
        bind $name.entry2 <<INVOKE>> $command
	bind $name.entry2 <Return> "$command;focus $a.next.ok;break"
	bind $name.entry2 <Button-1> "Set $name"
	$name.entry config -state disabled
 	$name.entry2 config -state disabled
     }
  if {$type==6} {
   set ButtonState $name.entry
	set a ".[lindex [split $name .] 1]"
	set textind [split $label ,]
      #N label + entries 
	label $name.label -text "[lindex $textind 0]:" -width $width1 -anchor w
	eval  {entry $name.entry -relief sunken -width $width1} $args
	pack $name.label $name.entry -side left
	bind $name.entry <<INVOKE>> $command
	bind $name.entry <Return> "$command;focus $a.next.ok;break"
	bind $name.entry <Button-1> "Set $name"
	bind $name.entry <Tab> $command
	set b2 ${name}.entry
	$b2 config -textvar val($b2)
  	for {set j 2} {$j<$label2} {incr j} {
	 set b2 ${name}.entry$j
	 set b3 ${name}.label$j	 
	 label $b3 -text [lindex $textind [expr $j-1]] -width $width1 -anchor w
	 eval  {entry $b2 -relief sunken -width $width1} $args
	 pack $b3 $b2 -side left
	 $b2 config -textvar val($b2)
	 puts "texvarname $b2"
	 bind $b2 <Tab> $command
         bind $b2 <<INVOKE>> $command
	 bind $b2 <Return> "$command;focus $a.next.ok;break"
	 bind $b2 <Button-1> "Set $name"
     } }
 return $name.entry
 }
proc Set {name} {
    set a [focus -lastfor $name]
    puts $a
    event generate $a <<INVOKE>>
}
    
#*************************************************************************#
proc ScaleButton {type name labs label2 btext ButtonNow width1 width2 command command2 args} {
      global v vals val Dchange MifKnow
      puts "$type  $name $labs  $ButtonNow"
      frame $name
	set b2 ${name}.scale
	scale $b2 -from 0 -to 10 -length 200 -variable vals($ButtonNow) \
	-orient horizontal -label $labs \
	-tickinterval 3 -showvalue true -command  "NewField $type $name $ButtonNow $width1 $width2 $command $command2 $args"
	pack $b2
      puts $ButtonNow
}
#*************************************************************************#
proc NewField {type name ButtonNow width1 width2 command command2 args}  {
 global MifKnow Dchange vals
 puts "$type $name $ButtonNow"
 set datanow [list $MifKnow($Dchange($ButtonNow))]
 lappend datanow $vals($ButtonNow)
 set MifKnow($Dchange($ButtonNow)) "$datanow"
 #frame ${name}.scales
 puts "datanow: $datanow"
 for {set j 0} {$j<$datanow} {incr j} {
    set b2 ${name}.scales
    MultiButton $type $b2 field "" 4 $ButtonNow $width1 $width2 $command $command2 $args 
 }
}
#*************************************************************************#
proc NewVal { ButtonNow }  {
 global MifKnow Dchange vals
 set datanow [list $MifKnow($Dchange($ButtonNow))]
 lappend datanow $vals($ButtonNow)
 set MifKnow($Dchange($ButtonNow)) "$datanow"
}
#*************************************************************************#
proc NewVal2 { ButtonNow offset ButtonState} {
 global MifKnow Dchange val
 set ButtonRef $ButtonState
 set i 1
 set j $offset
 while {[info commands $ButtonRef]!=""} {
   incr i   
   set ListElms [llength $MifKnow($Dchange($ButtonNow))]
   puts "$ListElms $val($ButtonRef) $ButtonRef" 
   if {$ListElms>$j} {                                             
      set MifKnow($Dchange($ButtonNow)) [lreplace $MifKnow($Dchange($ButtonNow)) $j $j $val($ButtonRef)]                       
   } else {                                                        
     lappend MifKnow($Dchange($ButtonNow)) $val($ButtonRef)                    
   }                      
    incr j
    set ButtonRef ${ButtonState}$i
 }	   
}
#*************************************************************************#
proc DisableEntry { ButtonNow x} {
  global MifKnow Dchange ButtonState
   set b2 ""
   set NULL ""
   if {$ButtonState!=$NULL} {
    $ButtonState config -textvar $NULL
    set last [$ButtonState index end]
    $ButtonState delete 0 $last 
    $ButtonState config -state disabled
    set b2 ${ButtonState}2
   }
   if {[info commands $b2]!=""} {
     $b2 config -textvar $NULL
     set last [$b2 index end]
     $b2 delete 0 $last 
     $b2 config -state disabled
   }
}
#*************************************************************************#
proc ChangeMif2 { Ref ButtonNow Command x} {
 global MifKnow Dchange ButtonState
 set ListElms [llength $MifKnow($Dchange($ButtonNow))]
 if {$ListElms>=2} {
   set MifKnow($Dchange($ButtonNow)) \
       [lreplace $MifKnow($Dchange($ButtonNow)) 1 $ListElms $Ref]
 } else {
   lappend MifKnow($Dchange($ButtonNow)) $Ref
 }
 if {$Command!="NULL"} {
  DisableEntry $Command $x
 }
} 
#*************************************************************************#
proc ChangeMif3 { Ref ButtonNow name type} {
 global MifKnow Dchange ButtonState val
 DisableEntry $ButtonNow ""
 set ListElms [llength $MifKnow($Dchange($ButtonNow))]
 if {$ListElms>=2} {
   set MifKnow($Dchange($ButtonNow)) \
       [lreplace $MifKnow($Dchange($ButtonNow)) 1 $ListElms $Ref]
 } else {
   lappend MifKnow($Dchange($ButtonNow)) $Ref
 }
 set ButtonState $name.entry
 set b2 $ButtonState
 set i 1
 while {[info commands $b2]!=""} {
   $b2 config -state normal
   set val($b2) "0.0"
   $b2 config -textvar val($b2)
   incr i   
   lappend MifKnow($Dchange($ButtonNow)) $val($b2)
   set b2 ${ButtonState}$i 
 }
 focus $name.entry 
 
}
#*************************************************************************#
proc SplitNToss {filename} {
 global inbuff MenuState
 set MenuState [list]
 puts $filename
 set listsize [ReadFile $filename]
 set firstbuff vals
 set FieldCount 0
 for {set i 0} {$i<$listsize} {incr i} {
   set shortbuff [string trim [lindex $inbuff $i]]
   regexp -nocase {^[^#]*[^#]*} $shortbuff firstbuff
   if {[string length $firstbuff]!=0} {
      set firstbuff [string trim [lindex [split $firstbuff :] 1 ]]
      #puts $firstbuff
      if {[string length $firstbuff]!=0} {
	  lappend MenuState $firstbuff
      }
   }
 }
}
#*************************************************************************#
proc EntryChange {filename ButtonNumber} {
 global inbuff MifKnow Mcontents val vals Dchange MenuState ButtonState MifBak
 set ButtonState ""
 set NULL "NULL"
 set prev [expr $ButtonNumber-1]
 set next [expr $ButtonNumber+1]
 foreach i [array names MifKnow] {set MifBak($i) $MifKnow($i)}      
 SplitNToss $filename
 #puts $MenuState
 #sets name of window
 set a [lindex $MenuState 0]
 toplevel $a ; after idle "OMF_SetIcon $a"
 #determines number of commands
 set ComNum [lindex $MenuState 1]
 #reads commands and options into a command array
 set i 2
 for {set Com 0} {$Com<$ComNum} {incr Com} {
   set comands($Com) [lindex $MenuState $i]
   incr i 
   set options($Com) [lindex $MenuState $i]
   incr i
 }
 #reads number of data changes and sets up frames
 set Types [lindex $MenuState $i]
 # variable Types holds number of mif changes in menu
 set ManyOld 0
 incr i
 for {set ButtonNow 1} {$ButtonNow<=$Types} {incr ButtonNow} {
  frame $a.$ButtonNow
  #Dchange hold mif changes; can be used with MifKnow
  set Dchange($ButtonNow) [lindex $MenuState $i]
  puts "$Dchange($ButtonNow) $ButtonNow"
  set loopn $Dchange($ButtonNow)
  incr i
  set vals($ButtonNow) [lindex $MifKnow($Dchange($ButtonNow)) 1]
  set MNow $MifKnow($Dchange($ButtonNow))
  #entries hold the number of options for a given MifChange
  set entries [lindex $MenuState $i]
  incr i
  set OptionMax [expr $entries + $ManyOld]   
  for {set j $ManyOld} {$j<$OptionMax} {incr j} {
    set shortbuff [split [lindex $MenuState $i] ! ]
    #Options Holds name & value of Menu choice    
    set Options($j) [lindex $shortbuff 0]
    incr i
    set b [lindex $shortbuff 0]
    set c [lindex $shortbuff 1]
    set type [lindex $shortbuff 2]
    set labname [lindex $shortbuff 3] 
    set labname2 [lindex $shortbuff 4]
    if {[lindex $shortbuff 5]==""} {
      set offset 1 
    } else {
      set offset [lindex $shortbuff 5]
    }
    
    set name [lindex $b 0]
    join $b
    eval $comands($c)
    set bname $a.$ButtonNow.$name 
    set cname "pack $bname $options($c)"
    eval $cname
    set check [string tolower [split [lindex $vals($ButtonNow) 0]]]
 
    if {$check==$b} {
	 set b2 $a.$ButtonNow.$name.button
	 if {[info commands $b2]!=""} { 
        set cname  "$b2 invoke" 
        eval $cname
       }
    }
    set ii $offset
	 set k 1
	 set b2 $bname.entry	 
	 while {[info commands $b2]!=""} {
         set val($b2) [lindex $MNow $ii]
	   #puts $f "Mnow: $MNow: [lindex $MNow $ii]:$k:$b2"
         incr ii 
         incr k
         set b2 ${bname}.entry$k 
       }  }
 pack $a.$ButtonNow 
 }
 frame $a.next
 button $a.next.next -text "Next" -command "Set $a; destroy $a ; CallNew $next"
 button $a.next.prev -text "Previous" -command "Set $a; destroy $a ; CallNew $prev"
 button $a.next.reset -text "Reset" -command "destroy $a ; CallBack $filename $ButtonNumber"
 button $a.next.ok -text "Ok" -command "Set $a; destroy $a"
 pack $a.next.ok $a.next.reset $a.next.next $a.next.prev -side left -expand true
 pack $a.next -fill x   
 bind $a.next.ok <Return> "destroy $a"
 bind $a.next.reset <Return> "destroy $a ; CallBack $filename $ButtonNumber"
 }
#*************************************************************************#
proc SaveMifFile {savefilename} {
 global MifKnow FieldState KnowOrder
 set file2Id [open $savefilename "w"]
 for {set one 1} {$one<[array size KnowOrder]} {incr one} { 
    set index $KnowOrder($one)
    set flipped $MifKnow($index)
    set vals [lindex $flipped 1]
    set vals2 [lindex $flipped 2]
    set vals3 [lindex $flipped 3]
    if {$vals!=""&&$vals!="field range"} {
	puts $file2Id "$index:$vals $vals2 $vals3"
	#puts $file2Id "$index:$flipped"
    }
    if {$index=="field range count"} {
     for {set iiii 1} {$iiii <= $vals} {incr iiii} {
      set pals $FieldState($iiii)
      puts $file2Id "field range: $pals"
     }
    }
 }
 close $file2Id
}
#**************************************************************************#  
# Library support
lappend auto_path $mmpe(libdir)
if {$tcl_version < 7.6} {
    lappend auto_path [file join $mmpe(libdir) em0.0]
    lappend auto_path [file join $mmpe(libdir) oommf0.0]
    lappend auto_path [file join $mmpe(libdir) net0.0]
}
package require em
package require oommf
package require net
proc SaveButton { btn } {
    if { [string match disabled [$btn cget -state]] } {
        return
    }
    set dialog [omf_mmssavedlg new -callback SaveCallback \
            -delete_callback_arg [list $btn configure -state normal]]
    $btn configure -state disabled
}
proc SaveCallback { widget actionid args } {
    if {[string match DELETE $actionid]} {
        eval $args
        return
    }
    if {[string match SAVE $actionid]} {
        SaveMifFile [$widget GetFilename]
    } else {
        return "ERROR (proc SaveCallBack): Invalid actionid: $actionid"
    }
}
proc LoadButton { btn } {
    if { [string match disabled [$btn cget -state]] } {
        return
    }
    set dialog [omf_mmsopendlg new -callback LoadCallback \
            -delete_callback_arg [list $btn configure -state normal]]
    $btn configure -state disabled
}
proc LoadCallback { widget actionid args } {
    if {[string match DELETE $actionid]} {
        eval $args
        return
    }
    if {[string match OPEN $actionid]} {
        ParseFile [$widget GetFilename]
    } else {
        return "ERROR (proc LoadCallBack): Invalid actionid: $actionid"
    }
}
#**************************************************************************#  
#top level window
KnowWhat [file join $mmpe(dirabs) state.dat]
ParseFile [file join $mmpe(dirabs) init.mif]
global TopButton
set listsize [ReadFile [file join $mmpe(dirabs) topmenu]]
for {set i 0} {$i<$listsize} {incr i} {
    set shortbuff [split [lindex $inbuff $i] : ]
    set buttoname [string tolower .[lindex $shortbuff 0]]
    set buttonspecs($i) [lindex $shortbuff 1]
    set filename [lindex $shortbuff 2]
    set fullfilename [file join $mmpe(dirabs) $filename]
    set TopButton($i) $fullfilename
    button $buttoname -text [lindex $shortbuff 0] \
	    -command "[lindex $shortbuff 1] $fullfilename $i"
    puts $buttoname
    if {![file readable $fullfilename]} {
	$buttoname configure -state disabled
    }
    pack $buttoname -fill x
}
button .write -text "Save" -command [list SaveButton .write]
button .load -text "Load" -command "KnowWhat [file join $mmpe(dirabs) state.dat];[list LoadButton .load]"
# Improve this later:
button .quit -text "Quit" -command { exit } 
pack .write .load .quit -side left -expand 1

# networking
if {!$nonet} {
    set protocol [net_protocol new -name "OOMMF ProbEd protocol 0.0"]
    $protocol AddMessage start HasGui {} {
	return [list start [list 0 0]]
    }
    $protocol AddMessage start GetProbDescFile {} {
        set fn [file join [pwd] tmp-[pid].mif]
        SaveMifFile $fn
        return [list start [list 0 $fn]]
    }
    set server [net_server new -protocol $protocol \
	    -alias mmProbEd -log em_nop]
    $server Start 0
    .quit configure -command { $protocol delete; after 2000 exit } 
    wm title . mmProbEd<[pid]>
    vwait omf_forever
}











