/* FILE: mmsolve.h                 -*-Mode: c++-*-
 *
 * Standard macro definitions.
 *
 */

#ifndef MMSOLVE_H
#define MMSOLVE_H

/*
 * These version numbers follow the Tcl version number convention.
 *
 * Goal is to have CVS handle updating of these values.
 * For now, edit them by hand.
 */
 
#define MMSOLVE_MAJOR_VERSION   0
#define MMSOLVE_MINOR_VERSION   0
#define MMSOLVE_RELEASE_LEVEL   1
#define MMSOLVE_RELEASE_SERIAL  0

// Possibly change this to a string of the full numeric version + patchlevel,
// so that the call to 'package provide' tells the whole story.
//
// Also try constructing these values out of those above to reduce 
// maintenance.
#define MMSOLVE_VERSION "0.0"
#define MMSOLVE_PATCH_LEVEL "0.0b0"

#include <tcl.h>
#include "oommf.h"	/* TCLCMD */

/*
 * VC++ has an alternate entry point called DllMain, so we need to rename
 * our entry point.
 */

#ifdef FUTURE_CODE
#if defined(__WIN32__)
#   define WIN32_LEAN_AND_MEAN
#   include <windows.h>
#   undef WIN32_LEAN_AND_MEAN
#   if defined(_MSC_VER)
#	define EXPORT(a,b) __declspec(dllexport) a b
#	define DllEntryPoint DllMain
#   else
#	if defined(__BORLANDC__)
#	    define EXPORT(a,b) a _export b
#	else
#	    define EXPORT(a,b) a b
#	endif
#   endif
#else
#   define EXPORT(a,b) a b
#endif
#else // !FUTURE_CODE
#   define EXPORT(a,b) a b
#endif // FUTURE_CODE

/* End includes */


TCLCMD Mms_MifCmd;
TCLCMD Mms_Grid2DCmd;
EXTERN EXPORT(int,Mmsolve_Init) _ANSI_ARGS_((Tcl_Interp *interp));
EXTERN EXPORT(int,Mmsolve_SafeInit) _ANSI_ARGS_((Tcl_Interp *interp));

#endif // MMSOLVE_H

