/* FILE: oommfport.h               -*-Mode: c++-*-
 *
 * Machine specific #define's and typedef's, generated by oommfport.tcl
 *
 */

#ifndef OOMMFPORT_H
#define OOMMFPORT_H

/* End includes */     /* Optional directive to build.tcl */

/* Include and defines files that *may* be system dependent. */
#include <stdlib.h>
#include <string.h>
#include <tcl.h>
#define MEMBLOCKSIZE 4096 /* Natural system memory blocksize.  Shouldn't  */
               /* affect program correctness, but may affect performance. */


/* Define the Tcl release level and serial if missing from tcl.h */
#ifndef TCL_RELEASE_LEVEL
#define TCL_RELEASE_LEVEL 2
#endif
#ifndef TCL_RELEASE_SERIAL
#define TCL_RELEASE_SERIAL 2
#endif
#ifndef TCL_PATCH_LEVEL
#define TCL_PATCH_LEVEL	   "8.0p2"
#endif

/* Check that the version of Tcl used to produce this file    */
/* agrees with the version number from tcl.h at compile time. */
/* Remove this check at your own risk!!!                      */
#if (TCL_MAJOR_VERSION  != 8) || \
    (TCL_MINOR_VERSION  != 0) || \
    (TCL_RELEASE_LEVEL  != 2) || \
    (TCL_RELEASE_SERIAL != 2)
#error tclsh (8.0.2.2) and tcl.h versions differ
#endif


/* The filename of the Tcl shell of the OOMMF project.         */
/* It is used to interpret Tcl scripts in sub-processess.      */
#define OMF_SHELL "omfsh"


/* The portion of the search path for the OOMMF project's Tcl  */
/* shell which is determined at configure/build time.          */
#define OMF_SHELL_STATIC_SEARCH_PATH "/home/fs3c/dgp/itest/bin /home/fs3c/dgp/OOMMF/oommf/bin-sun"

/* Variable type declarations.  The '****#m' */
/* types are at *least* '#' bytes wide.      */
typedef  int                 BOOL;
typedef  unsigned char       BYTE;
typedef  char                CHAR;
typedef  signed char        SCHAR;
typedef  unsigned char      UCHAR;
typedef  float              REAL4;
typedef  double             REAL8;
typedef  float              REAL4m;
typedef  double             REAL8m;
typedef  short               INT2;
typedef  unsigned short     UINT2;
typedef  int                 INT4;
typedef  unsigned int       UINT4;
typedef  int                 INT2m;
typedef  unsigned int       UINT2m;
typedef  int                 INT4m;
typedef  unsigned int       UINT4m;

#define POINTERWIDTH 4
#define BYTEORDER 1234

/* System type info */
#define UNIX 1
#define WINDOWS 2
#define MACINTOSH 3
#define SYSTEM_TYPE UNIX

/* Random number generator.  Replace with your own if you don't like    */
/* random().  Prototypes for random() and srandom() appear to be        */
/* missing from the Solaris system header files (though they are in the */
/* runtime library).  If you don't have random(), you can use rand()    */
/* instead, but be wary of some older, badly broken versions of rand(). */
extern "C" {
   /* If you get error messages about multiple inconsistent definitions  */
   /* of random or srandom, just yank out this prototype block.  (Better */
   /* yet, fix it up in your OOMMF/build/local.tcl file, as oommfport.h  */
   /* get rewritten whenever you do a 'build.tcl configure'              */
   long random(void);
   void srandom(unsigned int seed);
}
#define OMF_SRANDOM(seed)  srandom(seed)
#define OMF_RANDOM()       random()
#define OMF_RANDOM_MAX     0x7FFFFFFF /* Is this system dependent? */
    

/* For unix */
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>  /* Child process cleanup */

/* Directory path separator; Unix uses '/', DOS uses '\'. */
/* Rumor has it that the Mac uses ':'.                    */
#define DIRSEPCHAR '/'
#define DIRSEPSTR  "/"
#define PATHSPLITSTR ":"

#endif /* OOMMFPORT_H */
